package me.hammerle.scriptsystem;

import java.util.Collection;
import java.util.HashMap;

public class ScriptControl
{
    private int idCounter;
    private final HashMap<Integer, ScriptData> scripts;
    
    public ScriptControl() 
    {
        scripts = new HashMap<>();
        idCounter = 0;
    }    
    
    // -------------------------------------------------------------------------
    // Script - Verwaltung
    // -------------------------------------------------------------------------

    public ScriptData getScript(int id)
    {
        return scripts.get(id);
    }
    
    public void removeScripts()
    {
        //scripts.values().forEach(sd -> sd.setValid(false));
        scripts.clear();
    }
    
    public Collection<ScriptData> getScripts()
    {
        return scripts.values();
    }
    
    private void add(ScriptData sd)
    {
        scripts.put(sd.getId(), sd);
    }
    
    public void term(ScriptData sd)
    {
        /*if(sd == null)
        {
            return;
        }
        activeScript = sd.getIdBefore();
        ScriptData sda = getActiveScript();
        sda.setVar("return", sd.getVar("return"));
        sd.setValid(false);
        int id = sd.getId();
        SnuviScheduler.doScheduledTask(() -> scripts.remove(id));
        sda.nextCodeLine();
        CodeParser.continueCode(sda, null);*/
    }

    // -----------------------
    // Scripts laden und starten
    // -----------------------
  
    public void startScript(String scriptName)
    { 
        ScriptData sd = new ScriptData(idCounter, scriptName);
        idCounter++;
        add(sd);
        sd.runCode();
    }
}
